%{!?_pkgdocdir: %global _pkgdocdir %{_docdir}/%{name}-%{version}}
%{!?with_check: %global with_check 1}

%global		package_version 0.6.3
%global		package_name mom

%if 0%{?fedora} >= 30 || 0%{?rhel} >= 8
%global     python_interpreter %{__python3}
%global     python_target_version python3
%global     python_sitelib %{python3_sitelib}
%else
%global     python_interpreter %{__python2}
%global     python_target_version python2
%global     python_sitelib %{python2_sitelib}
%endif

Name:		%{package_name}
Version:	%{package_version}
Release:	1%{?dist}
Summary:	Dynamically manage system resources on virtualization hosts

License:	GPLv2
URL:		http://www.ovirt.org
Source:		https://resources.ovirt.org/pub/src/%{name}/%{package_name}-%{package_version}.tar.gz
BuildArch:	noarch
BuildRequires:	%{python_target_version}-devel
BuildRequires:	%{python_target_version}-nose
BuildRequires:	%{python_target_version}-mock

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: systemd

# MOM makes use of libvirt by way of the python bindings to monitor and
# interact with virtual machines.
Requires:	libvirt-daemon-driver-qemu
%if 0%{?fedora} >= 30 || 0%{?rhel} >= 8
Requires:	%{python_target_version}-libvirt
Requires:	%{python_target_version}-six
%else
Requires:	libvirt-python
Requires:	python-six
%endif
Requires:	procps


%description
MOM is a policy-driven tool that can be used to manage overcommitment on KVM
hosts. Using libvirt, MOM keeps track of active virtual machines on a host. At
a regular collection interval, data is gathered about the host and guests. Data
can come from multiple sources (eg. the /proc interface, libvirt API calls, a
client program connected to a guest, etc). Once collected, the data is
organized for use by the policy evaluation engine. When started, MOM accepts a
user-supplied overcommitment policy. This policy is regularly evaluated using
the latest collected data. In response to certain conditions, the policy may
trigger reconfiguration of the system’s overcommitment mechanisms. Currently
MOM supports control of memory ballooning and KSM but the architecture is
designed to accommodate new mechanisms such as cgroups.

%prep
%setup -q -n %{package_name}-%{package_version}

%build
%configure \
        PYTHON="%{python_interpreter}" \
        --docdir="%{_pkgdocdir}"
make %{?_smp_mflags}

%install
make DESTDIR="%{buildroot}" install

install -dm 755 %{buildroot}%{_unitdir}
install contrib/momd.service %{buildroot}%{_unitdir}
install -d -m 0755 "%{buildroot}/%{_sysconfdir}"
install -m 0644 doc/mom-balloon+ksm.conf "%{buildroot}/%{_sysconfdir}/momd.conf"

%check
%if 0%{with_check}
make check %{?_smp_mflags}
%endif

%post
%systemd_post momd.service

%preun
%systemd_preun momd.service

%postun
%systemd_postun_with_restart momd.service

%files
%config(noreplace) %{_sysconfdir}/momd.conf
%license COPYING
%doc README.md

%dir %{_pkgdocdir}/examples
%{_pkgdocdir}/examples/*
# COPYING is handled by license macro, avoid to ship duplicates
%exclude %{_pkgdocdir}/COPYING

%{_unitdir}/momd.service
%{_sbindir}/momd
%{python_sitelib}/mom/

%changelog
* Wed Jul 20 2022 Tomáš Golembiovský <tgolembi@redhat.com> - 0.6.3-1
- updated to upstream version 0.6.3

* Thu Mar  3 2022 Tomáš Golembiovský <tgolembi@redhat.com> - 0.6.2-1
- updated to upstream version 0.6.2

* Tue Apr 27 2021 Tomáš Golembiovský <tgolembi@redhat.com> - 0.6.1-1
- updated to upstream version 0.6.1

* Mon Nov 25 2019 Andrej Krejcir <akrejcir@redhat.com> - 0.6.0-1
- Release for el8

* Wed Sep 04 2019 Andrej Krejcir <akrejcir@redhat.com> - 0.5.16-1
- Python 3 compatibility fixes

* Thu Aug 01 2019 Andrej Krejcir <akrejcir@redhat.com> - 0.5.15-1
- Controllers convert floating point values to integers
  Resolves: rhbz#1733546

* Mon Jul 15 2019 Andrej Krejcir <akrejcir@redhat.com> - 0.5.14-1
- Rebase on upstream 0.5.14

* Tue Jul 02 2019 Sandro Bonazzola <sbonazzo@redhat.com> - 0.5.13-1
- Rebase on upstream 0.5.13

* Thu Feb  15 2018 Andrej Krejcir <akrejcir@redhat.com> - 0.5.12-1
- Rebase to the latest version

* Mon Nov  13 2017 Martin Sivak <msivak@redhat.com> - 0.5.11-1
- Rebase for RHV 4.2

* Thu Feb  09 2017 Martin Sivak <msivak@redhat.com> - 0.5.9-1
- Fix deprecation warning
  Resolves: rhbz#1413078

* Mon Oct  24 2016 Martin Sivak <msivak@redhat.com> - 0.5.8-1
- Support for jsonrpc (also depends on vdsm being updated)
  This fixes a missing file.
  Resolves: rhbz#1366556

* Mon Oct  17 2016 Martin Sivak <msivak@redhat.com> - 0.5.7-1
- Support for jsonrpc (also depends on vdsm being updated)
  Resolves: rhbz#1366556

* Wed Sep  07 2016 Martin Sivak <msivak@redhat.com> - 0.5.6-1
- Apply IO QoS even when no QoS was previously defined
  Resolves: rhbz#1201482

* Mon Jun  27 2016 Martin Sivak <msivak@redhat.com> - 0.5.5-1
- Improve message when a VM disappears
  Resolves: rhbz#1234953
- Add GuestIoTuneOptional collector
  Resolves: rhbz#1346252

* Wed Jun  1 2016 Martin Sivak <msivak@redhat.com> - 0.5.4-1
- Rebase to the latest version
- Use i8 XML-RPC extension for transfering big numbers
  Resolves: rhbz#1294833
- Fix the momd.service file syntax
  Resolves: rhbz#1263983
- Lower the load disk QoS imposes on VDSM
  Resolves: rhbz#1337228
- Add GuestBalloonOptional collector
  Resolves: rhbz#1337834

* Thu Apr 07 2016 Martin Sivak <msivak@redhat.com> - 0.5.3-1
- Add support for disk QoS
  Resolves: rhbz#1324919

* Mon Jan 25 2016 Martin Sivak <msivak@redhat.com> - 0.5.2-1
- Fix xml-rpc issues with big numbers on machines with more
  than 2 TiB of RAM
  Resolves: rhbz#1302001

* Thu Sep 17 2015 Martin Sivak <msivak@redhat.com> - 0.5.1-1
- Fix vdsmxmlrpc hypervisor interface when no ballooning
  information is present.
  Resolves: rhbz#1264095

* Thu Jul 16 2015 Martin Sivak <msivak@redhat.com> - 0.5.0-1
- Rebased to new single threaded upstream version

* Thu Jun 11 2015 Martin Sivak <msivak@redhat.com> - 0.4.5-2
- Rebased to new upstream version

* Thu Nov 27 2014 Martin Sivak <msivak@redhat.com> - 0.4.1-4
- Use new CPU tune values even if only one of quota or period
  was changed.
  Related: rhbz#1143992

* Fri Nov 21 2014 Martin Sivak <msivak@redhat.com> - 0.4.1-3
- Make CPU policy work even when guest agent is not installed
  Resolves: rhbz#1143992

* Wed Nov 12 2014 Martin Sivak <msivak@redhat.com> - 0.4.1-2
- Fix vcpuLimit KeyError test blocker
  Resolves: rhbz#1163386

* Mon Feb 10 2014 Martin Sivak <msivak@redhat.com> - 0.4.1-1
- Rebase to match the upstream version that has basic
  CPU QoS support
  Related: rhbz#906927

* Mon Feb 10 2014 Martin Sivak <msivak@redhat.com> - 0.4.0-1
- Rebase to match the upstream version
  Resolves: rhbz#1064427

* Tue Nov 26 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-8
- Use new evaluator (with new variable stack) for each policy
  run.
  Resolves: rhbz#1025845

* Fri Nov 22 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-7
- Fix KeyError exception while qemu-guest-agent error handling
- communicate with qemu-guest-agent using hypervisor_iface via libvirt
- Add support for optional collector fields and (null expr) test
  Related: rhbz#1025845
- Add support for swap information to be used in policy
  Related: rhbz#1025845
- Make the policy language more lisp like
- Add tests to MANIFEST.in and run them during an rpm build
- Fix balloon policy syntax and semantics
  Resolves: rhbz#1025845
- Convert some keys of mem_stats in getVmMemoryStats()
- Start memory stats collection on initialization

* Thu Aug 22 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-6
- Fix ever increasing CPU usage
  Resolves: rhbz#999973

* Wed Aug 21 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-5
- Fix the changelog
  Related: rhbz#822623

* Wed Aug 21 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-4
- Include upstream fixes for KSM and libvirt
  Related: rhbz#967562

* Wed Jul 31 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-3
- Accept ballon info in string form
  Related: rhbz#974917

* Thu Jul 18 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-1
- Update to keep the API in sync with VDSM
  Related: rhbz#822623

* Tue Jul 16 2013 Martin Sivak <msivak@redhat.com> - 0.3.1.1-1
- Upstream merged the patches we had
  Related: rhbz#822623

* Mon Jul 15 2013 Martin Sivak <msivak@redhat.com> - 0.3.1-1
- Initial package import
  Resolves: rhbz#822623
  Related: rhbz#967572
  Related: rhbz#967574
